## falconpl 0.9.6.6

=== CMakeLists.txt ===
#############################################################################
# The Falcon Programming language
#
# CMake configuration file for Core falcon
##############################################################################
#
# CONTROL VARIABLES:
#
# FALCON_BIN_DIR - Prefix for binary installation. Defaults to "bin"
# FALCON_INC_DIR - Prefix for installation of include files.
# FALCON_LIB_DIR - Prefix for installation of archives and dynamic libraries
#                  on UNIXes. Defaults to "lib".
# FALCON_MOD_DIR - Prefix for installation of modules. Defaults to
#                  $FALCON_LIB_DIR/falcon on UNICES, and bin/ on windows.
# FALCON_SKIP_BISON - ON to avoid using bison.
# FALCON_WITH_MANPAGES - ON to build and install man pages.
# FALCON_MAN_DIR - Where manual pages are stored (below prefix)
# FALCON_SHARE_DIR - Where to install falco share files
# FALCON_CMAKE_DIR - Where to install FalconConfig.cmake & c
#

cmake_minimum_required(VERSION 2.8)
project(Falcon_Core)

option( FALCON_SKIP_BISON "Skip BISON to avoid recompiling grammar" ON )

if(WIN32)
	option( FALCON_WITH_MANPAGES "Build and install also manpages" OFF )
else()
	# Manpages are mandatory on unix
	option( FALCON_WITH_MANPAGES "Build and install also manpages" ON )
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

# NOTE modules are installed via
#   install(FILES .. DESTINATION ${FALCON_MOD_INSTALL_DIR})
# since they are neither RUNTIME, LIBRARY nor ARCHIVE.

#In windows, we normally install in c:\falcon
if(WIN32)
   #mingw requires -mthreads global option
   if(CMAKE_GENERATOR STREQUAL "MinGW Makefiles")
      message( "MINGW make detected, adding -mthreads flag" )
      list(APPEND CMAKE_EXE_LINKER_FLAGS -mthreads )
      list(APPEND CMAKE_SHARED_LINKER_FLAGS -mthreads )
      list(APPEND CMAKE_MODULE_LINKER_FLAGS -mthreads )
   endif()
endif(WIN32)
#
## </Subset of falcon-config.cmake>

if(WIN32)
   SET( FALCON_HOST_SYSTEM "WINDOWS" )
   SET( FALCON_SYSTEM_WIN 1 )
else()
   if(APPLE)
      set( FALCON_HOST_SYSTEM "MAC" )
      set( FALCON_SYSTEM_MAC 1 )
   elseif(UNIX)
      set( FALCON_HOST_SYSTEM "UNIX" )
      SET( FALCON_SYSTEM_UNIX 1 )
   else()
      message(FATAL_ERROR "Sorry, can't determine system type" )
   endif()
endif()

#SONAME and soversion (unix so library informations for engine)
# Remember that SONAME never follows project versioning, but
# uses a VERSION, REVISION, AGE format, where
# VERSION: generational version of the project
# REVISION: times this version has been touched
# AGE: Number of version for which binary compatibility is granted
# In eample, 1.12.5 means that this lib may be dynlinked against
# every program using this lib versioned from 1.8 to 1.12.
include(versioninfo.cmake)
if(NOT FALCON_SONAME_AGE)
   # A couple of useful shortcuts
   set(FALCON_SONAME "${FALCON_SONAME_VERSION}.${FALCON_SONAME_REVISION}.${FALCON_SONAME_AGE}")
   set(FALCON_SONAME_REV "${FALCON_SONAME_VERSION}.${FALCON_SONAME_REVISION}")
endif(NOT FALCON_SONAME_AGE)

#Automatically generated version info for RC scripts and sources
#CMAKE is good at this, let's use this feature
set(FALCON_VERSION_RC   "${FALCON_VERSION_MAJOR}, ${FALCON_VERSION_MINOR}, ${FALCON_VERSION_REVISION}, ${FALCON_VERSION_PATCH}")
set(FALCON_VERSION_ID   "${FALCON_VERSION_MAJOR}.${FALCON_VERSION_MINOR}.${FALCON_VERSION_REVISION}.${FALCON_VERSION_PATCH}")
set(FALCON_ID   "${FALCON_VERSION_MAJOR}.${FALCON_VERSION_MINOR}.${FALCON_VERSION_REVISION}")

message(STATUS "Compiling Falcon ${FALCON_VERSION_ID} on ${CMAKE_SYSTEM}" )

##############################################################################
#  Other defaults
##############################################################################
include(TestBigEndian)

message(STATUS "Testing endianity on ${CMAKE_SYSTEM}" )
TEST_BIG_ENDIAN(falcon_big_endian)
if(falcon_big_endian)
   set(FALCON_LITTLE_ENDIAN 0)
else(falcon_big_endian)
   set(FALCON_LITTLE_ENDIAN 1)
endif(falcon_big_endian)


# install prefix defaults, if not set
if(NOT CMAKE_INSTALL_PREFIX)
  #In windows, we normally install in c:\falcon
  if(WIN32)
    if($ENV{PRGORAMS})
      SET(CMAKE_INSTALL_PREFIX  "C:\\\\$ENV{PROGRAMS}\\\\falcon" )
    else()
      SET(CMAKE_INSTALL_PREFIX  "C:\\\\Program Files\\\\falcon" )
    endif()
  else()
    set(CMAKE_INSTALL_PREFIX  "/usr/local" )
  endif()
endif()

message( STATUS "Installation prefix: ${CMAKE_INSTALL_PREFIX}" )

if (NOT FALCON_LIB_DIR)
   set(FALCON_LIB_DIR lib)
endif()

if( NOT FALCON_SHARE_DIR)
   if(WIN32)
      set(FALCON_SHARE_DIR "share")
   else()
      set(FALCON_SHARE_DIR "share/falcon${FALCON_ID}")
   endif()
endif()

if (NOT FALCON_BIN_DIR)
   set(FALCON_BIN_DIR bin)
endif()

if (NOT FALCON_INC_DIR)
   if(WIN32)
      set(FALCON_INC_DIR "include")
   else()
      set(FALCON_INC_DIR "include/falcon${FALCON_ID}")
   endif()
endif()

if (NOT FALCON_MOD_DIR )
   if(WIN32)
      set(FALCON_MOD_DIR bin)
   else()
      set(FALCON_MOD_DIR "${FALCON_LIB_DIR}/falcon")
   endif()
endif()

if(WIN32)
  set(FALCON_CMAKE_DIR cmake)
else()
  set(FALCON_CMAKE_DIR ${FALCON_SHARE_DIR}/cmake)
endif()

set(FALCON_APP_DIR ${FALCON_MOD_DIR}/apps)

# for install(TARGETS .. ${FALCON_INSTALL_DESTINATIONS})
set(FALCON_INSTALL_DESTINATIONS
  RUNTIME DESTINATION ${FALCON_BIN_DIR}
  LIBRARY DESTINATION ${FALCON_LIB_DIR}
  ARCHIVE DESTINATION ${FALCON_LIB_DIR}
)

message( STATUS "Binary prefix: ${FALCON_BIN_DIR}" )
message( STATUS "Library prefix: ${FALCON_LIB_DIR}" )
message( STATUS "Include prefix: ${FALCON_INC_DIR}" )
message( STATUS "Module prefix: ${FALCON_MOD_DIR}" )
message( STATUS "Application directory: ${FALCON_APP_DIR}" )
message( STATUS "CMAKE config prefix: ${FALCON_CMAKE_DIR}" )

if ( NOT WIN32 )
   if (NOT FALCON_MAN_DIR)
      set(FALCON_MAN_DIR "share/man/man1")
   endif()
   message( STATUS "Manual pages: ${FALCON_MAN_DIR}" )
endif()


#########################################################à
# List of files to be installed as docs
#

set( doc_files
      AUTHORS
      BUILDING
      ChangeLog
      copyright
      LICENSE
      README
      README.editline
      README.mersenne
      TODO
      LICENSE_GPLv2
      RELNOTES
   )

install(
   FILES ${doc_files}
   DESTINATION ${FALCON_SHARE_DIR} )

#########################################################à
# Subdirectories
#

#collect the include files in FALCON_HEADER
add_subdirectory(include)
#
add_subdirectory(engine)
add_subdirectory(clt)
add_subdirectory(devtools)


# and man pages
if (FALCON_WITH_MANPAGES)
   add_subdirectory(manpages)   
endif()

#########################################################################
# Feathers?
#
if( FALCON_WITH_FEATHERS )
   Message( STATUS "Adding FEATHERS to this build -- from ${FALCON_WITH_FEATHERS}" )
   
   #override settings for the include dirs
   set( Falcon_INCLUDE_DIRS "${CMAKE_CURRENT_BINARY_DIR}/include" )
   list( APPEND Falcon_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/include" )
   
   add_subdirectory( ${FALCON_WITH_FEATHERS} feathers_dir )
endif()


#########################################################################
# Tests?

option(FALCON_WITH_CTEST_TESTS "" off)
if(FALCON_WITH_CTEST_TESTS)
  enable_testing()
  include(CTest)
  add_subdirectory(tests)
endif()

# CMake generated information.  Is used by our falcon-config.cmake
install(EXPORT falcon-core-targets
  DESTINATION ${FALCON_CMAKE_DIR}
)

=== clt/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# CLT - Command Line Tools meta cmake file
##################################################

ADD_SUBDIRECTORY(faltest)
ADD_SUBDIRECTORY(faldisass)
ADD_SUBDIRECTORY(falrun)
ADD_SUBDIRECTORY(falcon)
ADD_SUBDIRECTORY(falpack)

=== devtools/CMakeLists.txt ===
#
# Configurator for development tools
#

# CMake will find it via find_package(falcon [REQUIRED])
# It supplies include paths, libraries (via falcon-core-targets.cmake)
# and convenience MACROS.
#

set( cmake_mod_files
   FalconConfig.cmake
   FalconConfigVersion.cmake )
   
foreach(item ${cmake_mod_files} )
  message( "Configuring ${item}" )
  configure_file(
    ${item}.in  "${CMAKE_CURRENT_BINARY_DIR}/${item}"
    ESCAPE_QUOTES @ONLY)

    #Create installation files from in files
    list( APPEND cmake_mod_files_inst "${CMAKE_CURRENT_BINARY_DIR}/${item}" )
endforeach()

#
# Configure other binary/executable files
#

IF(UNIX)
   SET(sys_in_spec falcon-conf )
   SET(sys_inst_spec ${CMAKE_CURRENT_BINARY_DIR}/falcon-conf)
ENDIF(UNIX)

SET(in_bin_files
  falconeer.fal
  ${sys_in_spec}
)

foreach(item ${in_bin_files} )
  message( "Configuring ${item}" )
  configure_file(
    ${item}.in  "${CMAKE_CURRENT_BINARY_DIR}/${item}"
    ESCAPE_QUOTES @ONLY)
    
    #Create installation files from in files
    list( APPEND inst_bin_files "${CMAKE_CURRENT_BINARY_DIR}/${item}" )
endforeach()

#
# Add non-configured files to be installed
#

list(APPEND inst_bin_files "fallc.fal")

########################################################################
# Install

install(
  FILES ${inst_bin_files}
  DESTINATION ${FALCON_BIN_DIR}
  PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE
              GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
)

install(
   FILES ${cmake_mod_files_inst}
   DESTINATION ${FALCON_CMAKE_DIR}
)

=== engine/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
##################################################

#Engine specific define
add_definitions(-DFALCON_ENGINE_EXPORTS)

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/core_module  
)

message(STATUS "Compiling Falcon core on ${CMAKE_SYSTEM_NAME}" )

#Specific system files
if(UNIX OR APPLE)
  set(SYS_SPECIFIC
    baton_posix.cpp
    dir_sys_unix.cpp
    fstream_sys_unix.cpp
    mt_posix.cpp
    stdstreams_unix.cpp
    time_sys_unix.cpp
    vm_sys_posix.cpp
    vfs_file_unix.cpp
    signals_posix.cpp
  )

  #for solaris system flavor, add sys_solaris.cpp
  if(CMAKE_SYSTEM_NAME STREQUAL "SunOS" )
    list(APPEND SYS_SPECIFIC sys_solaris.cpp)
  else()
    list(APPEND SYS_SPECIFIC sys_unix.cpp)
  endif()

  #DL is different for unix and mac
  if(APPLE)
    list(APPEND SYS_SPECIFIC 
      heap_bsd.cpp 
      dll_mac.cpp 
    )
  elseif(CMAKE_SYSTEM_NAME STREQUAL "BSD")
    list(APPEND SYS_SPECIFIC
      heap_bsd.cpp
      dll_dl.cpp 
    )
  else()
    list(APPEND SYS_SPECIFIC
      heap_posix.cpp
      dll_dl.cpp
    )
  endif()

  option(FALCON_SKIP_BISON "Don't perform grammar recompilation" on)
  if(NOT FALCON_SKIP_BISON)
    find_program(BISON_EXECUTABLE bison)
    if(NOT BISON_EXECUTABLE)
      message(FATAL_ERROR "BISON not found - Turn on FALCON_SKIP_BISON to not perform grammar recompilation")
    endif(NOT BISON_EXECUTABLE)
    
    # Builds out-of-source. Copy into the source tree and commit to svn, if desired.
    add_custom_command(
      DEPENDS 
        ${PROJECT_SOURCE_DIR}/include/falcon/syntree.h
        ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.yy
      COMMAND 
        ${BISON_EXECUTABLE} -y ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.yy 
                            -o ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.cpp       
      OUTPUT
        ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.cpp
        ${CMAKE_CURRENT_SOURCE_DIR}/src_parser.hpp 
      COMMENT "Creating src_parser.cpp"
    )

  endif(NOT FALCON_SKIP_BISON)

elseif(WIN32)

  set(SYS_SPECIFIC
    baton_win.cpp
    dir_sys_win.cpp
    dll_win.cpp
    fstream_sys_win.cpp
    heap_win.cpp
    mt_win.cpp
    stdstreams_win.cpp
    sys_win.cpp
    time_sys_win.cpp
    vm_sys_win.cpp
    vfs_file_win.cpp
    falcon_engine.rc
    signals_win.cpp
  )
endif()

#################

set(CORE_MODULE_SOURCES
  core_module/array_ext.cpp
  core_module/attrib_ext.cpp
  core_module/cmdlineparser.cpp
  core_module/complex_ext.cpp
  core_module/continuation_ext.cpp  
  core_module/core_module.cpp
  core_module/coroutine_ext.cpp
  core_module/dict_ext.cpp
  core_module/dir_ext.cpp
  core_module/envvars.cpp
  core_module/error_ext.cpp
  core_module/fal_include.cpp
  core_module/file_ext.cpp
  core_module/format_ext.cpp
  core_module/function_ext.cpp
  core_module/functional_ext.cpp
  core_module/gc_ext.cpp
  core_module/input.cpp
  core_module/inspect.cpp
  core_module/item_ext.cpp
  core_module/iterator_ext.cpp
  core_module/list_ext.cpp
  core_module/math_ext.cpp
  core_module/membuf_ext.cpp
  core_module/message_ext.cpp
  core_module/oob_ext.cpp
  core_module/pagedict_ext.cpp
  core_module/param_ext.cpp
  core_module/path_ext.cpp
  core_module/poopseq_ext.cpp
  core_module/print.cpp
  core_module/random.cpp
  core_module/seconds.cpp
  core_module/sequence_ext.cpp
  core_module/serialize.cpp
  core_module/set_ext.cpp
  core_module/string_ext.cpp
  core_module/state_ext.cpp
  core_module/stringstream_ext.cpp
  core_module/sys_ext.cpp
  core_module/table.cpp
  core_module/time_ext.cpp
  core_module/transcode_ext.cpp
  core_module/tokenizer_ext.cpp
  core_module/uri_ext.cpp
  core_module/vminfo_ext.cpp
  core_module/webhelp.cpp
)


add_library(falcon_engine SHARED
  attribmap.cpp
  autocstring.cpp
  autowstring.cpp
  base64.cpp
  basealloc.cpp
  cacheobject.cpp
  crobject.cpp
  compiler.cpp
  complex.cpp
  continuation.cpp
  corearray.cpp
  coreclass.cpp
  coredict.cpp
  corefunc.cpp
  coreobject.cpp
  coreslot.cpp
  coretable.cpp
  debug.cpp
  deptab.cpp
  error.cpp
  falcondata.cpp
  falconobject.cpp
  fassert.cpp
  filestat.cpp
  format.cpp
  garbageable.cpp
  gcalloc.cpp
  gencode.cpp
  generatorseq.cpp
  genericlist.cpp
  genericmap.cpp
  genericvector.cpp
  genhasm.cpp
  gentree.cpp
  globals.cpp
  intcomp.cpp
  item.cpp
  item_co.cpp
  itemarray.cpp
  itemlist.cpp
  itemserial.cpp
  itemset.cpp
  itemtraits.cpp
  iterator.cpp
  lineardict.cpp
  linemap.cpp
  livemodule.cpp
  ltree.cpp
  membuf.cpp
  memhash.cpp
  memory.cpp
  mempool.cpp
  modloader.cpp
  module.cpp
  modulecache.cpp
  pagedict.cpp
  path.cpp
  pcode.cpp
  poopseq.cpp
  proptable.cpp
  rampmode.cpp
  rangeseq.cpp
  reflectobject.cpp
  rosstream.cpp
  runtime.cpp
  sequence.cpp
  service.cpp
  smba.cpp
  src_lexer.cpp
  stackframe.cpp
  stream.cpp
  streambuffer.cpp
  string.cpp
  stringitem.cpp
  stringstream.cpp
  strtable.cpp
  symbol.cpp
  symtab.cpp
  syntree.cpp
  timestamp.cpp
  trace.cpp
  traits.cpp
  transcoding.cpp
  tokenizer.cpp
  uri.cpp
  vfsprovider.cpp
  vmcontext.cpp
  vm.cpp
  vmmaps.cpp
  vmmsg.cpp
  vm_run.cpp
  vmsema.cpp
  #
  src_parser.hpp
  src_parser.cpp
  #
  
  ${FALCON_HEADERS}
  
  ${CORE_MODULE_SOURCES}
  ${SYS_SPECIFIC}
)

set_target_properties(falcon_engine PROPERTIES
  VERSION "${FALCON_SONAME_VERSION}.${FALCON_SONAME_REVISION}.${FALCON_SONAME_AGE}"
  SOVERSION "${FALCON_SONAME_VERSION}"
)

#In unix and mac we have to add extra libraries
if(UNIX OR APPLE)
  #also dl for linux and solaris
  # and RT only for solaris and non-bsd systems
  set(SYS_LIBS pthread m)
  if(APPLE)
    list(APPEND SYS_LIBS dl)
  else()
    IF(CMAKE_SYSTEM_NAME MATCHES ".*BSD")
    else()
      list(APPEND SYS_LIBS dl rt)
    endif()
  endif()
  target_link_libraries(falcon_engine ${SYS_LIBS})
endif()

install(TARGETS falcon_engine 
  EXPORT falcon-core-targets
  ${FALCON_INSTALL_DESTINATIONS} 
)

=== feathers/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for Feather modules
####################################################################
cmake_minimum_required(VERSION 2.6.2)
PROJECT(Falcon_Feathers)

# Find our Find*.cmake files 
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/modules)

find_package(Falcon
   HINTS ${Falcon_Core_BINARY_DIR}/devtools
         "$ENV{FALCON_ACTIVE_TREE}/*/*/cmake"
         "$ENV{FALCON_ACTIVE_TREE}/*/cmake"
         "$ENV{FALCON_ACTIVE_TREE}/cmake"
   REQUIRED
)

include_directories(
  ${PROJECT_SOURCE_DIR}/include
  ${Falcon_INCLUDE_DIRS}
)

add_subdirectory(compiler)
add_subdirectory(confparser)
add_subdirectory(funcext)
add_subdirectory(hash)
add_subdirectory(json)
add_subdirectory(logging)
add_subdirectory(mxml)
add_subdirectory(process)
add_subdirectory(regex)
add_subdirectory(socket)
add_subdirectory(threading)
add_subdirectory(zlib)

# install headers
add_subdirectory(include)

option(FALCON_WITH_CTEST_TESTS "" off)
if(FALCON_WITH_CTEST_TESTS)
  enable_testing()
  include(CTest)
  add_subdirectory(tests)
endif()

=== manpages/CMakeLists.txt ===
#
# Install all the manual files.
#

cmake_minimum_required(VERSION 2.6)

#Find gzip
FIND_PROGRAM(GZIP_TOOL
             NAMES gzip
             PATHS /bin
                   /usr/bin
                   /usr/local/bin)

IF(NOT GZIP_TOOL)
  MESSAGE(FATAL_ERROR "Unable to find 'gzip' program")
ENDIF(NOT GZIP_TOOL)

# Use default man dir
if (NOT FALCON_MAN_DIR)
   set( FALCON_MAN_DIR "share/man/man1" )
endif()

file(GLOB SRC "*.1" )

FOREACH(man ${SRC})
   get_filename_component( mantarget ${man} NAME )
   
   ADD_CUSTOM_TARGET( ${mantarget} ALL
                     ${GZIP_TOOL} --best -c ${man} > ${mantarget}.gz
                     DEPENDS ${man}
                     COMMENT "Building ${mantarget}.gz")

   INSTALL( FILES ${CMAKE_CURRENT_BINARY_DIR}/${mantarget}.gz
            DESTINATION ${FALCON_MAN_DIR}
            PERMISSIONS OWNER_READ GROUP_READ WORLD_READ RENAME )
            
   list( APPEND targets ${mantarget}.gz )
ENDFOREACH()

=== tests/CMakeLists.txt ===
add_subdirectory(testsuite)

=== feathers/confparser/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module ConfParser
####################################################################

if(WIN32)
   set( SYS_RC confparser.rc )
endif(WIN32)

add_library(confparser_fm MODULE
  confparser.cpp
  confparser_ext.cpp
  confparser_mod.cpp
  confparser_st.cpp
  confparser_srv.cpp
  ${SYS_RC}
)

falcon_finalize_module( confparser_fm )

=== feathers/funcext/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module Funcext
####################################################################

if(WIN32)
   SET( SYS_RC funcext.rc )
endif()

add_library(funcext_fm MODULE
  funcext.cpp
  funcext_ext.cpp
  ${SYS_RC}
)

falcon_finalize_module( funcext_fm )

=== feathers/hash/CMakeLists.txt ===
####################################################################
# @MAIN_PRJ@
#
# CMake configuration file for hash
####################################################################

# Creates the proper module file name from the project name.
falcon_define_module( CURRENT_MODULE hash )

# Inclusion settings
include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}
)
# Enable this include if the project has a private include
#include_directories( ${PROJECT_SOURCE_DIR}/include )


# Sources files the module is built from.
set(SRC_FILES 
  hash.cpp
  hash_mod.cpp
  hash_srv.cpp
  hash_st.cpp
  hash_ext.cpp
  # add more source files starting here:
  adler32.cpp
  md2.cpp
  md4.cpp
  md5.cpp
  ripemd.cpp
  sha1.cpp
  sha256_sha224.cpp
  sha512_sha384.cpp
  tiger.cpp
  tiger_sboxes.cpp
  whirlpool.cpp

)

# These are actually not needed by cmake to build. But if omitted they won't be
# listed in the virtual file tree of Visual Studio.
set(HDR_FILES
  hash_ext.inl  
  hash_ext.h
  hash_mod.h
  hash_srv.h
  hash_st.h
  ../include/version.h
  hash_defs.h 
  # add more header files starting here:
  adler32.h
  sha1.h
  sha256_sha224.h
  sha512_sha384.h
  md2.h
  md4.h
  md5.h
  tiger.h
  whirlpool.h

)


# Builds and links from the source files
add_library( ${CURRENT_MODULE} MODULE
   ${SRC_FILES}
   ${HDR_FILES} # optional, see comment above.
)

# If your module needs some lib more, use the followings:
target_link_libraries( ${CURRENT_MODULE} falcon_engine)


falcon_install_module( ${CURRENT_MODULE} )

=== feathers/json/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module json
####################################################################

if(WIN32)
   SET( SYS_RC json.rc )
endif()

add_library(json_fm MODULE
   json_st.cpp
   json_mod.cpp
   json_ext.cpp
   json_srv.cpp
   json.cpp
   ${SYS_RC}
)

falcon_finalize_module( json_fm )

=== feathers/logging/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for module "logging"
####################################################################


if(WIN32)
   set( SYS_RC logging.rc )
   set( SYS_SRC logging_srv_win.cpp )
else()
   set( SYS_SRC logging_srv_syslog.cpp )
endif()

# Target
add_library(logging_fm MODULE
   logging.cpp
   logging_ext.cpp
   logging_mod.cpp
   logging_srv.cpp
   logging_st.cpp
   ${SYS_SRC}
   ${SYS_RC}
)

falcon_finalize_module( logging_fm )

=== debian/changelog ===
falconpl (0.9.6.6-0ubuntu1) natty; urgency=low

  * New upstream release (LP: #620204).
  * Now uses cmake to build the sources.
  * Add new binaries:
    - falpack: A packaging tool to copy all the modules and other dependencies
      needed for a standalone application to run into a target directory.
    - fallc.fal: Language table compiler to compile .ftt files (Falcon
      translation tables) into binary .ftr files (Falcon translation).
  * Bump Standards.

 -- Alessio Treglia <quadrispro@ubuntu.com>  Sun, 17 Oct 2010 13:37:42 +0200

=== debian/control ===
Source: falconpl
Section: interpreters
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Giancarlo Niccolai <gc@falconpl.org>
Standards-Version: 3.9.1
Build-Depends: cmake (>= 2.0),
 debhelper (>= 7.0.50~),
 bison (>= 1.8),
 zlib1g-dev,
 libpcre3-dev (>= 7.0)
Homepage: http://www.falconpl.org

Package: libfalcon-engine1
Architecture: any
Section: libs
Suggests: falconpl (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: The Falcon Programming Language engine
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 Falcon aims to be the next generation scripting language,
 providing a wide set of programming paradigms, template file
 processing for web development and document based applications,
 radical internationalization and application extension support.
 It is distributed under the Falcon Programming Language License,
 an open source license which grants usability of the language
 in any kind of application, including commercial ones.
 .
 This is the main engine of the language, including the engine,
 the Runtime Library and the essential modules.

Package: libfalcon-engine1-dbg
Architecture: any
Priority: extra
Section: debug
Suggests: libfalcon-engine1-dev (= ${binary:Version})
Depends: libfalcon-engine1 (= ${binary:Version}), ${misc:Depends}
Description: The Falcon P.L. engine - debugging symbols
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 Falcon aims to be the next generation scripting language,
 providing a wide set of programming paradigms, template file
 processing for web development and document based applications,
 radical internationalization and application extension support.
 It is distributed under the Falcon Programming Language License,
 an open source license which grants usability of the language
 in any kind of application, including commercial ones.
 .
 This package contains the debugging symbols for libfalcon-engine1
 package.

Package: falconpl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         libfalcon-engine1 (= ${binary:Version})
Description: The Falcon P. L. - command line tools
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 This is the set of command line tools that can be used to run
 stand-alone scripts and applications.

Package: falconpl-dbg
Architecture: any
Priority: extra
Section: debug
Suggests: falconpl-dev (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends},
         falconpl (= ${binary:Version})
Description: The Falcon P. L. - debugging symbols
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 This package contains the debugging symbols for the falconpl
 package.

Package: falconpl-dev
Architecture: any
Section: devel
Depends: ${shlibs:Depends}, ${misc:Depends},
         falconpl (= ${binary:Version})
Description: The Falcon PL - development files
 Falcon is a small, fast and powerful embeddable programming
 language. It is currently available for MS-Windows, Linux and
 Mac OS X platforms.
 .
 These are the files needed to develop new Falcon modules or
 to embed the Falcon Programming Language in other applications.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ -S cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DFALCON_INC_DIR=include \
		-DFALCON_SHARE_DIR=share/falconpl \
		-DFALCON_WITH_FEATHERS="feathers"

override_dh_auto_clean:
	rm -rf devel/release devel/settings*
	dh_auto_clean

override_dh_install:
	dh_install -plibfalcon-engine1 --sourcedir=debian/tmp
	dh_install -pfalconpl --sourcedir=debian/tmp
	dh_install -pfalconpl-dev --sourcedir=debian/tmp

override_dh_strip:
	dh_strip -plibfalcon-engine1 --dbg-package=libfalcon-engine1-dbg
	dh_strip -pfalconpl --dbg-package=falconpl-dbg
	dh_strip -pfalconpl-dev

override_dh_makeshlibs:
	dh_makeshlibs -plibfalcon-engine1 -V

=== debian/watch ===
version=3
http://www.falconpl.org/project_dl/_official_rel/Falcon-([\d\.]+)\.tar\.gz

## falconpl 0.9.6.9

=== CMakeLists.txt ===
#############################################################################
# The Falcon Programming language
#
# CMake configuration file for Core falcon
##############################################################################
#
##  Control Variables
#
# FALCON_BIN_DIR    - Prefix for binary installation. Defaults to "bin"
# FALCON_INC_DIR    - Prefix for installation of include files.
# FALCON_LIB_DIR    - Prefix for installation of archives and dynamic libraries
#                     on UNIXes. Defaults to "lib".
# FALCON_MOD_DIR    - Prefix for installation of modules. Defaults to
#                     $FALCON_LIB_DIR/falcon on UNICES, and bin/ on windows.
# FALCON_MAN_DIR    - Where manual pages are stored (below prefix)
# FALCON_SHARE_DIR  - Where to install falcon share files
# FALCON_CMAKE_DIR  - Where to install FalconConfig.cmake & c
#
##  Options
#
# FALCON_SKIP_BISON         - Turn ON to avoid using bison.
# FALCON_WITH_MANPAGES      - Turn ON to build and install man pages.
# FALCON_BUILD_FEATHERS     - Turn OFF to skip building Feathers.
# FALCON_BUILD_MODULES      - Turn OFF to skip building Falcon modules.
# FALCON_BUILD_NATMODS      - Turn OFF to skip building other binary native modules.
# FALCON_BUILD_APPS         - Turn ON to install installing Falcon applications.
# FALCON_BUILD_FWKS         - Turn OFF to skip installing Falcon frameworks.
# FALCON_BUILD_DOCS         - Build automatic documentation
#
##  Options For Native Modules
#
# FALCON_BUILD_*MODULE_NAME*    - ON to build a given module
#
# List of available modules: CURL DBI DBUS DYNLIB GD2 GTK PDF SDL
#

cmake_minimum_required(VERSION 2.6.2)
project(Falcon)


##################################################################
# Falcon build environment setup

set(Falcon_IN_CORE_SOURCETREE on)

# Find the module for cmake that we generate before install
set( Falcon_DIR "${CMAKE_CURRENT_BINARY_DIR}/devtools" )
#set( faldoc_DIR "${CMAKE_CURRENT_BINARY_DIR}/apps/faldoc")

# Add source include files at those generated by the module
list(APPEND Falcon_INCLUDE_DIRS
   "${CMAKE_CURRENT_SOURCE_DIR}/include"
   "${CMAKE_CURRENT_SOURCE_DIR}/modules/native/feathers/include"
)

include(detail.cmake)


##################################################################
# CMAKE environment setup
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)

#########################################################à
# List of files to be installed as docs
#

set( doc_files
      AUTHORS
      BUILDING
      ChangeLog
      copyright
      LICENSE
      README
      README.editline
      README.mersenne
      TODO
      LICENSE_GPLv2
      RELNOTES
   )

install(
   FILES ${doc_files}
   DESTINATION ${FALCON_SHARE_DIR} )

#########################################################à
# Subdirectories
#

#collect the include files in FALCON_HEADER
add_subdirectory(include)
#
add_subdirectory(engine)
add_subdirectory(clt)
#
add_subdirectory(devtools)

add_custom_target(falcon-core)

#########################################################################
# Feathers?
#
if( FALCON_BUILD_FEATHERS )
   message( STATUS "Adding FEATHERS to this build" )

   #override settings for the include dirs
   list( APPEND Falcon_INCLUDE_DIRS
      "${CMAKE_CURRENT_BINARY_DIR}/include" )

   add_subdirectory( modules/native/feathers )

else()
    message( STATUS "Not building feathers" )
endif()



#########################################################################
# Modules?
#
if( FALCON_BUILD_NATMODS )
    message( STATUS "Adding native binary modules to this build" )
    add_subdirectory( modules/native )
else()
    message( STATUS "Not building binary native modules" )
endif()

if( FALCON_BUILD_MODULES )
    message( STATUS "Adding Falcon modules to this build" )
    add_subdirectory( modules/falcon )
else()
    message( STATUS "Not building modules" )
endif()

if( FALCON_BUILD_FWKS )
    message( STATUS "Adding frameworks to this build" )
    add_subdirectory( frameworks )
else()
    message( STATUS "Not building frameworks" )
endif()

if( FALCON_BUILD_APPS )
    message( STATUS "Adding applications to this build" )
    add_subdirectory( apps )
else()
    message( STATUS "Not building applications" )
endif()

if( FALCON_BUILD_DOCS )
    message( STATUS "Adding documentation to this build" )
    add_subdirectory( docs )
else()
    message( STATUS "Not building documentation" )
endif()

#Generate make distro scripts
if( FALCON_BUILD_DIST )
	add_subdirectory( dist )
endif()

if( FALCON_INSTALL_TESTS )
    message( STATUS "Adding (source) tests, samples and demos to the distribution" )
    add_subdirectory( tests )
else()
    message( STATUS "Not installing tests" )
endif()

# CMake generated information.  Is used by our falcon-config.cmake
if (NOT FALCON_CMAKE_DIR)
   if(WIN32)
      set(FALCON_CMAKE_DIR cmake)
   else()
      set(FALCON_CMAKE_DIR ${FALCON_SHARE_DIR}/cmake)
   endif()
endif()

install(EXPORT falcon-core-targets
  DESTINATION ${FALCON_CMAKE_DIR}
)

=== falcon/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# Falcon command line
##################################################
option(FALCON_WITH_EDITLINE "Switch to ON for editline support." OFF)
option(FALCON_WITH_INTERNAL_EDITLINE "Switch to ON to use EDITLINE provided by falcon" ON)

if(WIN32)
   set(readline_SRC readline_simple.cpp)
   set( SYSTEM_RC falcon.rc)
else()  
   if(NOT FALCON_WITH_EDITLINE)
     set(readline_SRC readline_simple.cpp)
   else()
     set(readline_SRC readline_editline.cpp)
     if(FALCON_WITH_INTERNAL_EDITLINE)
       add_subdirectory(editline)
       set(Editline_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/editline/src)
       set(Editline_LIBRARY edit)
     else()
       find_package(Editline REQUIRED)
     endif()
  endif()
endif()

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${PROJECT_SOURCE_DIR}/include
  ${Editline_INCLUDE_DIRS}
  
)

add_executable( falcon
   falcon.cpp
   int_mode.cpp
   options.cpp
   ${readline_SRC}
   ${SYSTEM_RC}
)
if(EDITLINE_FOUND AND FALCON_WITH_GPL_READLINE)
  set_target_properties(falcon PROPERTIES 
    COMPILE_DEFINITIONS FALCON_WITH_GPL_READLINE
  )
endif()
target_link_libraries(falcon 
  falcon_engine
  ${Editline_LIBRARY}
)

install( TARGETS falcon ${FALCON_INSTALL_DESTINATIONS})

=== faldisass/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# Faldisass
##################################################

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIRECTORY}
  ${PROJECT_SOURCE_DIR}/include
)

IF(WIN32)
   SET(SYS_RC faldisass.rc)
ENDIF(WIN32)

# Target
ADD_EXECUTABLE( faldisass
   faldisass.cpp
   ${SYS_RC}
)

#Link
TARGET_LINK_LIBRARIES(faldisass falcon_engine)

#Install
INSTALL( TARGETS faldisass ${FALCON_INSTALL_DESTINATIONS} )

=== faldoc/CMakeLists.txt ===
####################################################################
# The Falcon Programming language
#
# CMake configuration file for Feather modules
####################################################################

cmake_minimum_required(VERSION 2.6.2)
project(falcon-app-faldoc)

set(FALDOC_DIR "${FALCON_APP_DIR}/faldoc" )

#install startup bat

if(UNIX)
   configure_file(
   faldoc.sh.in
   ${CMAKE_CURRENT_BINARY_DIR}/faldoc
   @ONLY
   )

   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/faldoc DESTINATION 
${FALCON_BIN_DIR}
   PERMISSIONS
      OWNER_READ OWNER_WRITE OWNER_EXECUTE
      GROUP_READ GROUP_EXECUTE
      WORLD_READ WORLD_EXECUTE
   )
else()
   configure_file(
   faldoc.bat.in
   ${CMAKE_CURRENT_BINARY_DIR}/faldoc.bat
   @ONLY
   )

   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/faldoc.bat DESTINATION 
${FALCON_BIN_DIR} )
endif()

install(FILES src/faldoc.fal DESTINATION ${FALDOC_DIR})
install(DIRECTORY src/faldoc DESTINATION ${FALDOC_DIR})
install(DIRECTORY src/resources DESTINATION ${FALDOC_DIR})

configure_file(
  faldoc-config.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/faldoc-config.cmake
  @ONLY
)       

install(
   FILES ${CMAKE_CURRENT_BINARY_DIR}/faldoc-config.cmake
   DESTINATION ${CMAKE_INSTALL_PREFIX}/share/cmake/faldoc
)

=== falrun/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# Falrun
##################################################

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIRECTORY}
  ${PROJECT_SOURCE_DIR}/include
)


IF(WIN32)
   SET(SYS_RC falrun.rc)
ENDIF(WIN32)

# Target
ADD_EXECUTABLE( falrun
   falrun.cpp
   ${SYS_RC}
)

#Link
TARGET_LINK_LIBRARIES(falrun falcon_engine)

#Install
INSTALL( TARGETS falrun ${FALCON_INSTALL_DESTINATIONS} )

=== faltest/CMakeLists.txt ===
##################################################
# Falcon Programming Language
#
# Faltest
##################################################

include_directories(
  ${PROJECT_BINARY_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIRECTORY}
  ${PROJECT_SOURCE_DIR}/include
)


IF(WIN32)
   SET(SYS_RC faltest.rc)
   SET(SYS_RC_DLL testsuite.rc)
ENDIF(WIN32)

# Target
ADD_EXECUTABLE( faltest
   faltest.cpp
   fal_testsuite.cpp
   scriptdata.cpp
   ${SYS_RC}
)

ADD_LIBRARY( testsuite_fm MODULE
   fal_testsuite.cpp
   ${SYS_RC_DLL}
)

#Link
TARGET_LINK_LIBRARIES(faltest falcon_engine)
TARGET_LINK_LIBRARIES(testsuite_fm falcon_engine)

#faltest embeds the testsuite module
SET_TARGET_PROPERTIES( faltest
   PROPERTIES COMPILE_FLAGS "-DFALCON_EMBED_MODULES")

#while the testsuite has no prefix
IF(APPLE)
SET_TARGET_PROPERTIES( testsuite_fm
   PROPERTIES 
	PREFIX ""
	SUFFIX ".dylib" )
ELSE(APPLE)
SET_TARGET_PROPERTIES( testsuite_fm
   PROPERTIES PREFIX "")
ENDIF(APPLE)

#Install
INSTALL( TARGETS faltest ${FALCON_INSTALL_DESTINATIONS})

INSTALL( TARGETS testsuite_fm
      DESTINATION ${FALCON_MOD_DIR} )

=== manpages/CMakeLists.txt ===
#
# Install all the manual files.
#

find_program(GZIP_TOOL
  NAMES gzip
  PATHS
    /bin
    /usr/bin
    /usr/local/bin
)

if(NOT GZIP_TOOL)
  message(FATAL_ERROR "Unable to find 'gzip' program")
endif(NOT GZIP_TOOL)

# Use default man dir
if (NOT FALCON_MAN_DIR)
   set( FALCON_MAN_DIR "share/man/man1" )
endif()

file(GLOB SRC "*.1" )

foreach(man ${SRC})
   get_filename_component( mantarget ${man} NAME )

   add_custom_command(
     OUTPUT ${mantarget}.gz
     COMMAND ${GZIP_TOOL} --best -c ${man} > ${mantarget}.gz
     DEPENDS ${man}
     COMMENT "Building ${mantarget}.gz"
   )
   add_custom_target( ${mantarget} ALL
     DEPENDS ${mantarget}.gz
   )

   install(
     FILES ${CMAKE_CURRENT_BINARY_DIR}/${mantarget}.gz
     DESTINATION ${FALCON_MAN_DIR}
     PERMISSIONS OWNER_READ GROUP_READ WORLD_READ RENAME
   )

   list( APPEND targets ${mantarget}.gz )
endforeach()

=== native/CMakeLists.txt ===
###############################################################################
# Falcon Programming language
# Build and installation suite
#
# Native modules
#

list( APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake )

#########################################################
# Utilities used in this section
#
macro( FalconMakeBinding module lib desc )

   if( FALCON_NATMODS_AUTO )
      find_package( ${lib} )
      if ( ${lib}_FOUND )
         option( FALCON_BUILD_${module} "${desc}" ON )
      else()
         option( FALCON_BUILD_${module} "${desc}" OFF )
      endif()
   else()
      option( FALCON_BUILD_${module} "${desc}" OFF )
   endif()

endmacro()

#########################################################

OPTION( FALCON_NATMODS_AUTO "Select automatically all the modules that have support" ON )

# Native modules, usually compiled
OPTION( FALCON_BUILD_DBI "Install DBI module" ON )
OPTION( FALCON_BUILD_DYNLIB "Install DYNLIB module" OFF)
OPTION( FALCON_BUILD_MONGODB "Install MongoDB module" ON )

# Bindings -- native modules requiring external libraries.
FalconMakeBinding( CURL CURL "Install CURL binding" )
FalconMakeBinding( SDL SDL "Install SDL  binding" )


# Other modules
option( FALCON_BUILD_WOPI "Install Web Oriented Programming Interface" OFF  )

# TODO: foreach ftw
if( FALCON_NATMODS_AUTO )

   #### Check DBUS
   find_path( DBUS_INCLUDE_DIR dbus.h HINTS /usr/include/dbus-1.0/dbus )
   if ( DBUS_INCLUDE_DIR )
      set( _dbus ON )
   endif()

   #### Check DataMatrix
   include( FalconFindDataMatrix )

   #### Check HPDF (LibHARU)
   find_path( LibHaru_INCLUE_DIR hpdf.h )
   if ( LibHaru_INCLUE_DIR )
      set( _pdf ON )
   endif()

   #### Check GD2
   find_path( GD_INCLUDE_DIR gd.h )
   if ( GD_INCLUDE_DIR )
      set( _gd2 ON )
   endif()

   #### Check GTK2
   include( FalconFindGTK2 )

else()
  set( _dbus OFF )
  set( _dmtx OFF )
  set( _gd2 OFF )
  set( _gtk OFF )
  set( _pdf OFF )
endif()

# Bindings -- Requiring more sophisticated checks
option( FALCON_BUILD_DBUS "Install DBUS binding"  ${_dbus})
option( FALCON_BUILD_DMTX "Install DataMatrix binding" ${_dmtx} )
option( FALCON_BUILD_GD2 "Install GD library binding" ${_gd2})
option( FALCON_BUILD_GTK "Install GTK2 module" ${_gtk} )
option( FALCON_BUILD_PDF "Install libharu (hpdf)  binding" ${_pdf})

#########################################################
# Inclusion statements
#

if(FALCON_BUILD_CURL)
   add_subdirectory( curl )
endif()

if ( FALCON_BUILD_DBI )
    add_subdirectory( dbi )
endif()

if ( FALCON_BUILD_DBUS )
    add_subdirectory( dbus )
endif()

if ( FALCON_BUILD_DMTX )
    add_subdirectory( dmtx )
endif()

if ( FALCON_BUILD_DYNLIB )
    add_subdirectory( dynlib )
endif()

if ( FALCON_BUILD_GD2 )
    add_subdirectory( gd2 )
endif()

if ( FALCON_BUILD_GTK )
    add_subdirectory( gtk )
endif()

if ( FALCON_BUILD_MONGODB )
    add_subdirectory( mongodb )
endif()

if ( FALCON_BUILD_PDF )
    add_subdirectory( hpdf )
endif()

if ( FALCON_BUILD_SDL )
    add_subdirectory( sdl )
endif()

if ( FALCON_BUILD_WOPI )
    add_subdirectory( wopi )
endif()

if ( FALCON_BUILD_CONIO )
    add_subdirectory( conio )
endif()

=== nest/CMakeLists.txt ===
############################################################
# CMake list for nest framework.
#

set( module_dirs
   nest
)

falcon_install_moddirs( ${module_dirs} )
install( DIRECTORY nest/res DESTINATION "${FALCON_MOD_DIR}/nest" )

=== nsis/CMakeLists.txt ===
#
# Configurator for NSIS installer
#
cmake_minimum_required(VERSION 2.6)

#
# Files to be configured
#
SET( config_files

  falcon_inst.nsi
)

# Files to be copied
SET( copy_files

	fileassoc.nsh
	WriteEnvStr.nsh
	AddToPath.nsh
)

# Directories to be copied
SET( copy_directories
		
	Resources
)


##################################################
# Prepare configure-time variables for NSIS script
#

if( "${CMAKE_GENERATOR}" STREQUAL "MinGW Makefiles" )
   set( FALCON_ENGINE_DLL "libFalcon_engine.dll" )
   set( FALCON_ENGINE_LIB "libFalcon_engine.dll.a" )
   
   find_library(MINGW_MD_RUNTIME mingwm10)
   get_filename_component(_filename ${MINGW_MD_RUNTIME} NAME)
   configure_file( ${MINGW_MD_RUNTIME} ${Falcon_BINARY_DIR}/${_filename} COPYONLY)
   
   set( FALCON_BUILD_NAME "MinGW" )
   
else()
   set( FALCON_ENGINE_DLL "Falcon_engine.dll" )
   set( FALCON_ENGINE_LIB "Falcon_engine.lib" )
   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 10" )
	  set( FALCON_BUILD_NAME "VS10" )
   endif()
   
   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 10 Win64" )
	  set( FALCON_BUILD_NAME "VS10_64" )
   endif()
   
   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 6" )
	  set( FALCON_BUILD_NAME "VS6" )
   endif()

   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 8 2005" )
	  set( FALCON_BUILD_NAME "VS8" )
   endif()

   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 8 2005 Win64" )
	  set( FALCON_BUILD_NAME "VS8_64" )
   endif()
   
   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 9 2008" )
	  set( FALCON_BUILD_NAME "VS9" )
   endif()

   if( "${CMAKE_GENERATOR}" STREQUAL "Visual Studio 9 2008 Win64" )
	  set( FALCON_BUILD_NAME "VS9_64" )
   endif()
	
   if(NOT FALCON_BUILD_NAME )
	  set( FALCON_BUILD_NAME  "Win32" )
   endif()

endif()


if ( ${FALCON_VERSION_REVISION} EQUAL 0 )
   if ( ${FALCON_VERSION_PATCH} EQUAL 0 )
      set( FALCON_VF_NAME  
         "${FALCON_VERSION_MAJOR}_${FALCON_VERSION_MINOR}_${FALCON_BUILD_NAME}" )
   else()
      set( FALCON_VF_NAME  
         "${FALCON_VERSION_MAJOR}_${FALCON_VERSION_MINOR}_${FALCON_VERSION_REVISION}_${FALCON_VERSION_PATCH}" )
   endif()
else()
   set( FALCON_VF_NAME  
      "${FALCON_VERSION_MAJOR}_${FALCON_VERSION_MINOR}_${FALCON_VERSION_REVISION}_${FALCON_VERSION_PATCH}_${FALCON_BUILD_NAME}" )
endif()

################################################
# Execute what required
#

foreach( item ${config_files} )
  message( "Configuring ${item}" )
  configure_file(
    ${item}.in  "${CMAKE_CURRENT_BINARY_DIR}/${item}"
    ESCAPE_QUOTES @ONLY)
    
    #Create installation files from in files
    list( APPEND inst_files "${CMAKE_CURRENT_BINARY_DIR}/${item}" )
endforeach()

foreach( item ${copy_files} )
  message( "Copying ${item}" )
  list( APPEND inst_files "${CMAKE_CURRENT_SOURCE_DIR}/${item}" )
endforeach()

########################################################################
# Install

install(
  FILES ${inst_files}
  DESTINATION dist
  PERMISSIONS OWNER_READ OWNER_WRITE
              GROUP_READ GROUP_EXECUTE
              WORLD_READ WORLD_EXECUTE
)

foreach( item ${copy_directories} )
	install(
		DIRECTORY ${item}
		DESTINATION dist
	)
endforeach()

=== core/testsuite/CMakeLists.txt ===
set(categories
  RTL
  basic
  classes
  comp
  expression
  expressions
  fbom
  function
  functional
  functions
  gc
  iterators
  lambda
  loops
  macro
  membuf
  messages
  meta
  methods
  modloader
  poop
  prototype
  reference
  rtl
  select
  smoke
  statements
  states
  switch
  tabular
  template
  types
)

# clean this directory from artefacts of former faltest runs
file(GLOB _fams "*.fam") 
if(_fams)
  file(REMOVE ${_fams})
endif(_fams)

# start memcheck ignore list 
file(WRITE ${CMAKE_BINARY_DIR}/CTestCustom.cmake "set(CTEST_CUSTOM_MEMCHECK_IGNORE\n")

add_test(testsuite_all ${CMAKE_COMMAND} -P test_driver.cmake) 
file(APPEND ${CMAKE_BINARY_DIR}/CTestCustom.cmake "  testsuite_all\n")   

foreach(category ${categories})
  add_test(testsuite_category_${category} ${CMAKE_COMMAND} -Dtest_category=${category} -P test_driver.cmake) 
  file(APPEND ${CMAKE_BINARY_DIR}/CTestCustom.cmake "  testsuite_category_${category}\n")   
endforeach(category)

# wrap memcheck ignore list up
file(APPEND ${CMAKE_BINARY_DIR}/CTestCustom.cmake ")")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/test_driver.cmake.in 
  ${CMAKE_CURRENT_BINARY_DIR}/test_driver.cmake
  @ONLY
)

=== falcon/editline/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)
project(Editline)

find_package(Curses REQUIRED)
set(HAVE_CURSES_H ${CURSES_HAVE_CURSES_H})
set(HAVE_NCURSES_H ${CURSES_HAVE_NCURSES_H} )

add_subdirectory(src)
#add_subdirectory(examples)

include(CheckIncludeFile)
include(CheckFunctionExists)
include(CheckTypeSize)
include(CheckSymbolExists)
check_include_file("sys/cdefs.h" HAVE_SYS_CDEFS_H)
check_include_file("term.h" HAVE_TERM_H)
check_function_exists("getpwuid_r" HAVE_GETPW_R_POSIX)
check_type_size("u_int32_t" U_INT32_T)
check_symbol_exists(alloca alloca.h HAVE_ALLOCA)
set(HAVE_ALLOCA_H ${HAVE_ALLOCA})

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config.h
)
